X-Git-Url: https://git.saurik.com/apt.git/blobdiff_plain/9e141dbd05e0304eada7e1eaf9a224018fa18132..9b8c28f430a8fbe73252cc3e87b6e88e9d5063d9:/test/integration/test-bug-595691-empty-and-broken-archive-files

diff --git a/test/integration/test-bug-595691-empty-and-broken-archive-files b/test/integration/test-bug-595691-empty-and-broken-archive-files
index 11dee0628..486b8ba02 100755
--- a/test/integration/test-bug-595691-empty-and-broken-archive-files
+++ b/test/integration/test-bug-595691-empty-and-broken-archive-files
@@ -11,9 +11,9 @@ touch aptarchive/Packages
 setupflataptarchive
 
 testaptgetupdate() {
-	rm -rf rootdir/var/lib/apt rootdir/var/cache/apt
-	aptget update 2>> testaptgetupdate.diff >> testaptgetupdate.diff || true
-	sed -i -e '/^Fetched / d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
+	rm -rf rootdir/var/lib/apt
+	aptget update >testaptgetupdate.diff 2>&1 || true
+	sed -i -e '/Ign /,+1d' -e '/Release/ d' -e 's#Get:[0-9]\+ #Get: #' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
 	GIVEN="$1"
 	shift
 	msgtest "Test for correctness of" "apt-get update with $*"
@@ -28,10 +28,10 @@ testaptgetupdate() {
 createemptyarchive() {
 	find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
 	if [ "en" = "$1" ]; then
-		echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+		echo -n "" | $COMPRESSOR_CMD > aptarchive/Packages.$COMPRESS
 	fi
 	touch aptarchive/Packages
-	echo -n "" | $COMPRESSOR > aptarchive/${1}.$COMPRESS
+	echo -n "" | $COMPRESSOR_CMD > aptarchive/${1}.$COMPRESS
 	generatereleasefiles
 	signreleasefiles
 	rm -f aptarchive/Packages
@@ -40,7 +40,7 @@ createemptyarchive() {
 createemptyfile() {
 	find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
 	if [ "en" = "$1" ]; then
-		echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+		echo -n "" | $COMPRESSOR_CMD > aptarchive/Packages.$COMPRESS
 	fi
 	touch aptarchive/Packages aptarchive/${1}.$COMPRESS
 	generatereleasefiles
@@ -48,54 +48,22 @@ createemptyfile() {
 	rm -f aptarchive/Packages
 }
 
-setupcompressor() {
-	COMPRESSOR="$1"
-	case $COMPRESSOR in
-	gzip) COMPRESS="gz";;
-	bzip2) COMPRESS="bz2";;
-	lzma) COMPRESS="lzma";;
-	xz) COMPRESS="xz";;
-	esac
-	echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
-Dir::Bin::uncompressed \"/does/not/exist\";
-Dir::Bin::gzip \"/does/not/exist\";
-Dir::Bin::bzip2 \"/does/not/exist\";
-Dir::Bin::lzma \"/does/not/exist\";
-Dir::Bin::xz \"/does/not/exist\";" > rootdir/etc/apt/apt.conf.d/00compressor
-	if [ -e "/bin/${COMPRESSOR}" ]; then
-		echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
-	elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
-		echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
-	else
-		msgtest "Test for availability of compressor" "${COMPRESSOR}"
-		msgfail
-		exit 1
-	fi
-}
-
 testoverfile() {
-	setupcompressor "$1"
+	forcecompressor "$1"
 
 	createemptyfile 'en'
-	testaptgetupdate "Get:1 file:  InRelease []
-Ign file:  Translation-en
-Reading package lists..." "empty file en.$COMPRESS over file"
+	testaptgetupdate 'Reading package lists...' "empty file en.$COMPRESS over file"
 
 	createemptyarchive 'en'
-	testaptgetupdate "Get:1 file:  InRelease []
-Reading package lists..." "empty archive en.$COMPRESS over file"
+	testaptgetupdate 'Reading package lists...' "empty archive en.$COMPRESS over file"
 
 	createemptyarchive 'Packages'
 	# FIXME: Why omits the file transport the Packages Get line?
 	#Get:3 file:  Packages []
-	testaptgetupdate "Get:1 file:  InRelease []
-Ign file:  Translation-en
-Reading package lists..." "empty archive Packages.$COMPRESS over file"
+	testaptgetupdate 'Reading package lists...' "empty archive Packages.$COMPRESS over file"
 
 	createemptyfile 'Packages'
-	testaptgetupdate "Get:1 file:  InRelease []
-Ign file:  Translation-en
-Err file:  Packages
+	testaptgetupdate "Err file:  Packages
   Empty files can't be valid archives
 W: Failed to fetch ${COMPRESSOR}:$(readlink -f aptarchive/Packages.$COMPRESS)  Empty files can't be valid archives
 
@@ -103,35 +71,18 @@ E: Some index files failed to download. They have been ignored, or old ones used
 }
 
 testoverhttp() {
-	setupcompressor "$1"
-
-	createemptyfile 'en'
-	testaptgetupdate "Get:1 http://localhost  InRelease []
-Get:2 http://localhost  Packages []
-Get:3 http://localhost  Translation-en
-Ign http://localhost  Translation-en
-Reading package lists..." "empty file en.$COMPRESS over http"
-
-	createemptyarchive 'en'
-	testaptgetupdate "Get:1 http://localhost  InRelease []
-Get:2 http://localhost  Packages []
-Get:3 http://localhost  Translation-en []
-Reading package lists..." "empty archive en.$COMPRESS over http"
+	forcecompressor "$1"
 
 	createemptyarchive 'Packages'
-	testaptgetupdate "Get:1 http://localhost  InRelease []
-Get:2 http://localhost  Packages []
-Ign http://localhost  Translation-en
+	testaptgetupdate "Get: http://localhost:8080  Packages []
 Reading package lists..." "empty archive Packages.$COMPRESS over http"
 
 	createemptyfile 'Packages'
 	#FIXME: we should response with a good error message instead
-	testaptgetupdate "Get:1 http://localhost  InRelease []
-Get:2 http://localhost  Packages
-Ign http://localhost  Translation-en
-Err http://localhost  Packages
+	testaptgetupdate "Get: http://localhost:8080  Packages
+Err http://localhost:8080  Packages
   Empty files can't be valid archives
-W: Failed to fetch ${COMPRESSOR}:$(readlink -f rootdir/var/lib/apt/lists/partial/localhost:8080_Packages)  Empty files can't be valid archives
+W: Failed to fetch ${COMPRESSOR}:$(readlink -f rootdir/var/lib/apt/lists/partial/localhost:8080_Packages.${COMPRESS})  Empty files can't be valid archives
 
 E: Some index files failed to download. They have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over http"
 }